Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Tests/Util.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Tests/Util.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Tests/Util.cs	(revision 5733)
@@ -53,5 +53,5 @@
       for (int i = 0; i < trees.Count; i++) {
         foreach (var node in trees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count() > 0) {
+          if (node.Subtrees.Count() > 0) {
             if (!occurances.ContainsKey(node.Symbol.Name))
               occurances[node.Symbol.Name] = 0;
@@ -70,12 +70,12 @@
     }
 
-    public static string GetNumberOfSubTreesDistributionString(IList<ISymbolicExpressionTree> trees) {
+    public static string GetNumberOfSubtreesDistributionString(IList<ISymbolicExpressionTree> trees) {
       Dictionary<int, int> occurances = new Dictionary<int, int>();
       double n = 0.0;
       for (int i = 0; i < trees.Count; i++) {
         foreach (var node in trees[i].IterateNodesPrefix()) {
-          if (!occurances.ContainsKey(node.SubTrees.Count()))
-            occurances[node.SubTrees.Count()] = 0;
-          occurances[node.SubTrees.Count()]++;
+          if (!occurances.ContainsKey(node.Subtrees.Count()))
+            occurances[node.Subtrees.Count()] = 0;
+          occurances[node.Subtrees.Count()]++;
           n++;
         }
@@ -96,5 +96,5 @@
       for (int i = 0; i < trees.Count; i++) {
         foreach (var node in trees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count() == 0) {
+          if (node.Subtrees.Count() == 0) {
             if (!occurances.ContainsKey(node.Symbol.Name))
               occurances[node.Symbol.Name] = 0;
@@ -118,5 +118,5 @@
       Assert.AreEqual(actualSize, reportedSize);
 
-      foreach (var defunTreeNode in tree.Root.SubTrees.OfType<DefunTreeNode>()) {
+      foreach (var defunTreeNode in tree.Root.Subtrees.OfType<DefunTreeNode>()) {
         int arity = defunTreeNode.NumberOfArguments;
 
@@ -133,5 +133,5 @@
 
         var invoke = new InvokeFunction(defunTreeNode.FunctionName);
-        foreach (var otherRootNode in tree.Root.SubTrees) {
+        foreach (var otherRootNode in tree.Root.Subtrees) {
           if (otherRootNode.Grammar.ContainsSymbol(invoke)) {
             Assert.IsTrue(otherRootNode.Grammar.GetMinimumSubtreeCount(invoke) == arity);
@@ -141,5 +141,5 @@
 
       }
-      foreach (var subtree in tree.Root.SubTrees) {
+      foreach (var subtree in tree.Root.Subtrees) {
         Assert.AreNotSame(subtree.Grammar, tree.Root.Grammar);
         IsValid(subtree.Grammar);
@@ -165,10 +165,10 @@
                             where symb.Name == treeNode.Symbol.Name
                             select symb).SingleOrDefault();
-      Assert.IsTrue(treeNode.SubTrees.Count() >= treeNode.Grammar.GetMinimumSubtreeCount(matchingSymbol));
-      Assert.IsTrue(treeNode.SubTrees.Count() <= treeNode.Grammar.GetMaximumSubtreeCount(matchingSymbol));
+      Assert.IsTrue(treeNode.Subtrees.Count() >= treeNode.Grammar.GetMinimumSubtreeCount(matchingSymbol));
+      Assert.IsTrue(treeNode.Subtrees.Count() <= treeNode.Grammar.GetMaximumSubtreeCount(matchingSymbol));
       Assert.AreNotEqual(0.0, matchingSymbol.InitialFrequency); // check that no deactivated symbols occur in the tree
-      for (int i = 0; i < treeNode.SubTrees.Count(); i++) {
-        Assert.IsTrue(treeNode.Grammar.GetAllowedChildSymbols(treeNode.Symbol, i).Select(x => x.Name).Contains(treeNode.GetSubTree(i).Symbol.Name));
-        IsValid(treeNode.GetSubTree(i));
+      for (int i = 0; i < treeNode.Subtrees.Count(); i++) {
+        Assert.IsTrue(treeNode.Grammar.GetAllowedChildSymbols(treeNode.Symbol, i).Select(x => x.Name).Contains(treeNode.GetSubtree(i).Symbol.Name));
+        IsValid(treeNode.GetSubtree(i));
       }
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/AntInterpreter.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/AntInterpreter.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/AntInterpreter.cs	(revision 5733)
@@ -51,5 +51,5 @@
 
     private SymbolicExpressionTreeNode FindMatchingFunction(string name) {
-      foreach (var defunBranch in expression.Root.SubTrees.OfType<DefunTreeNode>()) {
+      foreach (var defunBranch in expression.Root.Subtrees.OfType<DefunTreeNode>()) {
         if (defunBranch.FunctionName == name) return defunBranch;
       }
@@ -93,5 +93,5 @@
       // expression evaluated completly => start at root again
       if (nodeStack.Count == 0) {
-        nodeStack.Push(Expression.Root.GetSubTree(0).GetSubTree(0));
+        nodeStack.Push(Expression.Root.GetSubtree(0).GetSubtree(0));
       }
 
@@ -114,16 +114,16 @@
         NextField(out nextAntLocationRow, out nextAntLocationColumn);
         if (World[nextAntLocationRow, nextAntLocationColumn]) {
-          nodeStack.Push(currentNode.GetSubTree(0));
+          nodeStack.Push(currentNode.GetSubtree(0));
         } else {
-          nodeStack.Push(currentNode.GetSubTree(1));
+          nodeStack.Push(currentNode.GetSubtree(1));
         }
       } else if (currentNode.Symbol is Prog2) {
-        nodeStack.Push(currentNode.GetSubTree(1));
-        nodeStack.Push(currentNode.GetSubTree(0));
+        nodeStack.Push(currentNode.GetSubtree(1));
+        nodeStack.Push(currentNode.GetSubtree(0));
         return;
       } else if (currentNode.Symbol is Prog3) {
-        nodeStack.Push(currentNode.GetSubTree(2));
-        nodeStack.Push(currentNode.GetSubTree(1));
-        nodeStack.Push(currentNode.GetSubTree(0));
+        nodeStack.Push(currentNode.GetSubtree(2));
+        nodeStack.Push(currentNode.GetSubtree(1));
+        nodeStack.Push(currentNode.GetSubtree(0));
         return;
       } else if (currentNode.Symbol is InvokeFunction) {
@@ -131,13 +131,13 @@
         var functionDefinition = (SymbolicExpressionTreeNode)FindMatchingFunction(invokeNode.Symbol.FunctionName).Clone();
         var argumentCutPoints = (from node in functionDefinition.IterateNodesPrefix()
-                                 where node.SubTrees.Count() > 0
-                                 from subtree in node.SubTrees
+                                 where node.Subtrees.Count() > 0
+                                 from subtree in node.Subtrees
                                  where subtree is ArgumentTreeNode
-                                 select new { Parent = node, Argument = subtree.Symbol as Argument, ChildIndex = node.IndexOfSubTree(subtree) }).ToList();
+                                 select new { Parent = node, Argument = subtree.Symbol as Argument, ChildIndex = node.IndexOfSubtree(subtree) }).ToList();
         foreach (var cutPoint in argumentCutPoints) {
-          cutPoint.Parent.RemoveSubTree(cutPoint.ChildIndex);
-          cutPoint.Parent.InsertSubTree(cutPoint.ChildIndex, (SymbolicExpressionTreeNode)invokeNode.GetSubTree(cutPoint.Argument.ArgumentIndex).Clone());
+          cutPoint.Parent.RemoveSubtree(cutPoint.ChildIndex);
+          cutPoint.Parent.InsertSubtree(cutPoint.ChildIndex, (SymbolicExpressionTreeNode)invokeNode.GetSubtree(cutPoint.Argument.ArgumentIndex).Clone());
         }
-        nodeStack.Push(functionDefinition.GetSubTree(0));
+        nodeStack.Push(functionDefinition.GetSubtree(0));
       } else {
         throw new InvalidOperationException(currentNode.Symbol.ToString());
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs	(revision 5733)
@@ -30,5 +30,5 @@
   [StorableClass]
   [Creatable("Problems")]
-  public class SymbolicClassificationMultiObjectiveProblem : SymbolicDataAnalysisMultiObjectiveProblem<IClassificationProblemData, ISymbolicClassificationMultiObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator> {
+  public class SymbolicClassificationMultiObjectiveProblem : SymbolicDataAnalysisMultiObjectiveProblem<IClassificationProblemData, ISymbolicClassificationMultiObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator>, IClassificationProblem {
     private const double PunishmentFactor = 10;
     private const int InitialMaximumTreeDepth = 8;
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs	(revision 5733)
@@ -30,5 +30,5 @@
   [StorableClass]
   [Creatable("Problems")]
-  public class SymbolicClassificationSingleObjectiveProblem : SymbolicDataAnalysisSingleObjectiveProblem<IClassificationProblemData, ISymbolicClassificationSingleObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator> {
+  public class SymbolicClassificationSingleObjectiveProblem : SymbolicDataAnalysisSingleObjectiveProblem<IClassificationProblemData, ISymbolicClassificationSingleObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator>, IClassificationProblem {
     private const double PunishmentFactor = 10;
     private const int InitialMaximumTreeDepth = 8;
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj	(revision 5733)
@@ -111,6 +111,4 @@
     <Compile Include="SymbolicRegressionModel.cs" />
     <Compile Include="Interfaces\ISymbolicRegressionModel.cs" />
-    <Compile Include="Interfaces\ISymbolicRegressionProblem.cs" />
-    <Compile Include="Interfaces\ISymbolicRegressionSingleObjectiveProblem.cs" />
     <Compile Include="Interfaces\ISymbolicRegressionSolution.cs" />
     <Compile Include="Interfaces\ISymbolicRegressionEvaluator.cs" />
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs	(revision 5733)
@@ -31,5 +31,5 @@
   [StorableClass]
   [Creatable("Problems")]
-  public class SymbolicRegressionMultiObjectiveProblem : SymbolicDataAnalysisMultiObjectiveProblem<IRegressionProblemData, ISymbolicRegressionMultiObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator> {
+  public class SymbolicRegressionMultiObjectiveProblem : SymbolicDataAnalysisMultiObjectiveProblem<IRegressionProblemData, ISymbolicRegressionMultiObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator>, IRegressionProblem {
     private const double PunishmentFactor = 10;
     private const int InitialMaximumTreeDepth = 8;
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs	(revision 5733)
@@ -31,5 +31,5 @@
   [StorableClass]
   [Creatable("Problems")]
-  public class SymbolicRegressionSingleObjectiveProblem : SymbolicDataAnalysisSingleObjectiveProblem<IRegressionProblemData, ISymbolicRegressionSingleObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator> {
+  public class SymbolicRegressionSingleObjectiveProblem : SymbolicDataAnalysisSingleObjectiveProblem<IRegressionProblemData, ISymbolicRegressionSingleObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator>,IRegressionProblem {
     private const double PunishmentFactor = 10;
     private const int InitialMaximumTreeDepth = 8;
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 5733)
@@ -73,12 +73,12 @@
       ConstantTreeNode betaTreeNode = null;
       // check if model has been scaled previously by analyzing the structure of the tree
-      var startNode = Model.SymbolicExpressionTree.Root.GetSubTree(0);
-      if (startNode.GetSubTree(0).Symbol is Addition) {
-        var addNode = startNode.GetSubTree(0);
-        if (addNode.SubtreesCount == 2 && addNode.GetSubTree(0).Symbol is Multiplication && addNode.GetSubTree(1).Symbol is Constant) {
-          alphaTreeNode = addNode.GetSubTree(1) as ConstantTreeNode;
-          var mulNode = addNode.GetSubTree(0);
-          if (mulNode.SubtreesCount == 2 && mulNode.GetSubTree(1).Symbol is Constant) {
-            betaTreeNode = mulNode.GetSubTree(1) as ConstantTreeNode;
+      var startNode = Model.SymbolicExpressionTree.Root.GetSubtree(0);
+      if (startNode.GetSubtree(0).Symbol is Addition) {
+        var addNode = startNode.GetSubtree(0);
+        if (addNode.SubtreesCount == 2 && addNode.GetSubtree(0).Symbol is Multiplication && addNode.GetSubtree(1).Symbol is Constant) {
+          alphaTreeNode = addNode.GetSubtree(1) as ConstantTreeNode;
+          var mulNode = addNode.GetSubtree(0);
+          if (mulNode.SubtreesCount == 2 && mulNode.GetSubtree(1).Symbol is Constant) {
+            betaTreeNode = mulNode.GetSubtree(1) as ConstantTreeNode;
           }
         }
@@ -90,8 +90,8 @@
         alphaTreeNode.Value += alpha;
       } else {
-        var mainBranch = startNode.GetSubTree(0);
-        startNode.RemoveSubTree(0);
+        var mainBranch = startNode.GetSubtree(0);
+        startNode.RemoveSubtree(0);
         var scaledMainBranch = MakeSum(MakeProduct(beta, mainBranch), alpha);
-        startNode.AddSubTree(scaledMainBranch);
+        startNode.AddSubtree(scaledMainBranch);
       }
 
@@ -105,6 +105,6 @@
         var node = (new Addition()).CreateTreeNode();
         var alphaConst = MakeConstant(alpha);
-        node.AddSubTree(treeNode);
-        node.AddSubTree(alphaConst);
+        node.AddSubtree(treeNode);
+        node.AddSubtree(alphaConst);
         return node;
       }
@@ -117,6 +117,6 @@
         var node = (new Multiplication()).CreateTreeNode();
         var betaConst = MakeConstant(beta);
-        node.AddSubTree(treeNode);
-        node.AddSubTree(betaConst);
+        node.AddSubtree(treeNode);
+        node.AddSubtree(betaConst);
         return node;
       }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs	(revision 5733)
@@ -153,19 +153,19 @@
         var varCondNode = node as VariableConditionTreeNode;
         IncReferenceCount(references, varCondNode.VariableName, currentLag);
-        GetVariableReferences(references, node.GetSubTree(0), currentLag);
-        GetVariableReferences(references, node.GetSubTree(1), currentLag);
+        GetVariableReferences(references, node.GetSubtree(0), currentLag);
+        GetVariableReferences(references, node.GetSubtree(1), currentLag);
       } else if (node.Symbol is Integral) {
         var laggedNode = node as LaggedTreeNode;
         for (int l = laggedNode.Lag; l <= 0; l++) {
-          GetVariableReferences(references, node.GetSubTree(0), currentLag + l);
+          GetVariableReferences(references, node.GetSubtree(0), currentLag + l);
         }
       } else if (node.Symbol is Derivative) {
         var laggedNode = node as LaggedTreeNode;
         for (int l = laggedNode.Lag; l <= 0; l++) {
-          GetVariableReferences(references, node.GetSubTree(0), currentLag + l);
+          GetVariableReferences(references, node.GetSubtree(0), currentLag + l);
         }
       } else if (node.Symbol is TimeLag) {
         var laggedNode = node as LaggedTreeNode;
-        GetVariableReferences(references, node.GetSubTree(0), currentLag + laggedNode.Lag);
+        GetVariableReferences(references, node.GetSubtree(0), currentLag + laggedNode.Lag);
       }
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 5733)
@@ -185,5 +185,4 @@
     <Compile Include="Interfaces\ISymbolicDataAnalysisSolution.cs" />
     <Compile Include="Interfaces\ISymbolicDataAnalysisSolutionCreator.cs" />
-    <Compile Include="Interfaces\ISymbolicDataAnalysisProblem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
